diff -uNr src.ORIG/mclibs/herwig/code/hwdhig.F src/mclibs/herwig/code/hwdhig.F
--- src.ORIG/mclibs/herwig/code/hwdhig.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwdhig.F	2005-05-31 02:34:40.000000000 +0900
@@ -10,6 +10,9 @@
 C                     FOR EMH=GAMINP. STORE RESULT IN GAMINP.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWDHGF,HWRGEN,HWRUNI,HWUSQR,HWUPCM,GAMINP,EMH,
      & EMF,COLFAC,ENF,K1,K0,BET0,BET1,GAM0,GAM1,SCLOG,CFAC,XF,EM,GAMLIM,
      & GAM,XW,EMW,XZ,EMZ,YW,YZ,EMI,TAUT,TAUW,WIDHIG,VECDEC,EMB,GAMB,
@@ -27,10 +30,29 @@
       IF (GAMINP.EQ.0) THEN
         IHIG=0
         DO 10 I=1,NHEP
+#if !defined(CERNLIB_GFORTRAN)
  10       IF (IHIG.EQ.0.AND.IDHW(I).EQ.201.AND.ISTHEP(I).EQ.1) IHIG=I
+#else
+             IF (IHIG.EQ.0.AND.IDHW(I).EQ.201.AND.ISTHEP(I).EQ.1) IHIG=I
+ 10       continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (IHIG.EQ.0) CALL HWWARN('HWDHIG',101,*999)
+#else
+        if (IHIG.EQ.0) then
+          call hwwarn('HWDHIG',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         EMH=PHEP(5,IHIG)
+#if !defined(CERNLIB_GFORTRAN)
         IF (EMH.LE.0) CALL HWWARN('HWDHIG',102,*999)
+#else
+        if (EMH.LE.0) then
+          call hwwarn('HWDHIG',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         EMSCA=EMH
       ELSE
         EMH=GAMINP
@@ -44,7 +66,12 @@
 C---NLL CORRECTION TO QUARK DECAY RATE (HHG eq 2.6-9)
       ENF=0
       DO 1 I=1,6
+#if !defined(CERNLIB_GFORTRAN)
  1      IF (2*RMASS(I).LT.EMH) ENF=ENF+1
+#else
+            IF (2*RMASS(I).LT.EMH) ENF=ENF+1
+ 1      continue
+#endif
       K1=5/PIFAC**2
       K0=3/(4*PIFAC**2)
       BET0=(11*CAFAC-2*ENF)/3
@@ -107,10 +134,27 @@
       WIDHIG=0
       DO 200 IPART=1, 12
         IF (IPART.LT.12) BRHIG(IPART)=BRHIG(IPART)*ENHANC(IPART)**2
+#if !defined(CERNLIB_GFORTRAN)
  200    WIDHIG=WIDHIG+BRHIG(IPART)
+#else
+          WIDHIG=WIDHIG+BRHIG(IPART)
+ 200    continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
       IF (WIDHIG.EQ.0) CALL HWWARN('HWDHIG',103,*999)
+#else
+      if (WIDHIG.EQ.0) then
+          call hwwarn('HWDHIG',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       DO 300 IPART=1, 12
+#if !defined(CERNLIB_GFORTRAN)
  300    BRHIG(IPART)=BRHIG(IPART)/WIDHIG
+#else
+          BRHIG(IPART)=BRHIG(IPART)/WIDHIG
+ 300    continue
+#endif
       IF (EM.NE.RMASS(201)) THEN
 C---SET UP W*W*/Z*Z* LOOKUP TABLES
         EM=EMH
@@ -141,7 +185,12 @@
         IF (BRHIG(IMODE).LT.HWRGEN(0)) GOTO 500
       ENDIF
 C---SEE IF SPECIFIED DECAY IS POSSIBLE
+#if !defined(CERNLIB_GFORTRAN)
       IF (BRHIG(IMODE).EQ.0) CALL HWWARN('HWDHIG',104,*999)
+#else
+      IF (BRHIG(IMODE).EQ.0) call hwwarn('HWDHIG',104,iret)
+        if (iret .eq. 1) go to 999
+#endif
       IF (IMODE.LE.6) THEN
         IDEC=IMODE
       ELSEIF (IMODE.LE.9) THEN
@@ -205,7 +254,14 @@
       ENDIF
 C---DO DECAY
       PCM=HWUPCM(EMH,PHEP(5,NHEP+1),PHEP(5,NHEP+2))
+#if !defined(CERNLIB_GFORTRAN)
       IF (PCM.LT.0) CALL HWWARN('HWDHIG',105,*999)
+#else
+      if (PCM.LT.0) then
+          call hwwarn('HWDHIG',105,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       CALL HWDTWO(PHEP(1,IHIG),PHEP(1,NHEP+1),PHEP(1,NHEP+2),
      &            PCM,TWO,.TRUE.)
       NHEP=NHEP+2
diff -uNr src.ORIG/mclibs/herwig/code/hwdhqk.F src/mclibs/herwig/code/hwdhqk.F
--- src.ORIG/mclibs/herwig/code/hwdhqk.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwdhqk.F	2005-05-31 02:34:40.000000000 +0900
@@ -7,6 +7,9 @@
 C     Performs weak decays of heavy quarks: 0 -> W + 3,  W -> 1 + 2(bar)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWULDO,RN,BF,EMMX,EMWSQ,GMWSQ,EMLIM,PW(4),
      & EMTST
       INTEGER IST(3),IHEP,IS,ID,IM,I,LHEP,MHEP
@@ -28,9 +31,21 @@
         DO 20 I=1,NMODES(ID)
         BF=BF+BRFRAC(IM)
         IF (BF.GE.RN) GOTO 30
+#if !defined(CERNLIB_GFORTRAN)
   20    IM=LNEXT(IM)
+#else
+           IM=LNEXT(IM)
+  20    continue
+#endif
         CALL HWWARN('HWDHQK',50,*30)
+#if !defined(CERNLIB_GFORTRAN)
   30    IF (NHEP+4.GT.NMXHEP) CALL HWWARN('HWDHQK',100,*999)
+#else
+  30    if (NHEP+4.GT.NMXHEP) then
+          call hwwarn('HWDHQK',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C Make a copy of decaying heavy (anti-)quark
         NHEP=NHEP+1
         ISTHEP(NHEP)=155
@@ -41,7 +56,12 @@
         IF (IDHEP(IHEP).GT.0) THEN
 C Re-set pointer of quark's colour mother
           IF (JDAHEP(2,JMOHEP(2,IHEP)).NE.IHEP)
+#if !defined(CERNLIB_GFORTRAN)
      &      CALL HWWARN('HWDHQK',98,*999)
+#else
+     &      call hwwarn('HWDHQK',98,iret)
+        if (iret .eq. 1) go to 999
+#endif
           JDAHEP(2,JMOHEP(2,IHEP))=NHEP
 C and pointer of flavour partner
           IF (JMOHEP(2,JDAHEP(2,IHEP)).EQ.IHEP)
@@ -49,7 +69,12 @@
         ELSE
 C Re-set pointer of anti-quark's colour daughter
           IF (JMOHEP(2,JDAHEP(2,IHEP)).NE.IHEP)
+#if !defined(CERNLIB_GFORTRAN)
      &      CALL HWWARN('HWDHQK',99,*999)
+#else
+     &      call hwwarn('HWDHQK',99,iret)
+        if (iret .eq. 1) go to 999
+#endif
           JMOHEP(2,JDAHEP(2,IHEP))=NHEP
 C and pointer of anti-flavour partner
           IF (JDAHEP(2,JMOHEP(2,IHEP)).EQ.IHEP)
@@ -77,8 +102,13 @@
         JMOHEP(2,NHEP)=MHEP
         JDAHEP(1,NHEP)=0
         JDAHEP(2,NHEP)=MHEP
+#if !defined(CERNLIB_GFORTRAN)
   40    PHEP(5,NHEP)=RMASS(IDKPRD(I,IM))
 C Assign production vertex to 3 (and W)
+#else
+           PHEP(5,NHEP)=RMASS(IDKPRD(I,IM))
+  40    continue
+#endif
         CALL HWUDKL(ID,PHEP(1,IHEP),VHEP(1,NHEP))
         CALL HWVSUM(4,VHEP(1,IHEP),VHEP(1,NHEP),VHEP(1,NHEP))
         IF (NME(IM).EQ.130) THEN
diff -uNr src.ORIG/mclibs/herwig/code/hwdhvy.F src/mclibs/herwig/code/hwdhvy.F
--- src.ORIG/mclibs/herwig/code/hwdhvy.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwdhvy.F	2005-05-31 02:34:40.000000000 +0900
@@ -9,6 +9,9 @@
 C     or, quarkonia -> 2-gluons, q-qbar, 3-gluons, or 2-gluons + photon.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWULDO,HWRGEN,XS,XB,EMWSQ,GMWSQ,EMLIM,PW(4),
      & EMTST,X1,X2,X3,TEST
       INTEGER IST(3),I,IHEP,IM,ID,IDQ,IQ,IS,J
@@ -20,7 +23,12 @@
       IHEP=LOCQ(I)
       IF (ISTHEP(IHEP).EQ.199) GOTO 100
       IM=IMQDK(I)
+#if !defined(CERNLIB_GFORTRAN)
       IF (NHEP+NPRODS(IM).GT.NMXHEP) CALL HWWARN('HWDHVY',100,*999)
+#else
+      IF (NHEP+NPRODS(IM).GT.NMXHEP) call hwwarn('HWDHVY',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
       IF (IDKPRD(4,IM).NE.0) THEN
 C Weak decay of meson or baryon
 C Idenitify decaying heavy quark and spectator
@@ -53,10 +61,22 @@
           IQ=NHEP+2
         ELSE
 C Decay not recognized
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWDHVY',100,*999)
+#else
+          call hwwarn('HWDHVY',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
 C Label constituents
+#if !defined(CERNLIB_GFORTRAN)
         IF (NHEP+5.GT.NMXHEP) CALL HWWARN('HWDHVY',101,*999)
+#else
+        if (NHEP+5.GT.NMXHEP) then
+          call hwwarn('HWDHVY',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         ISTHEP(IHEP)=199
         JDAHEP(1,IHEP)=NHEP+1
         JDAHEP(2,IHEP)=NHEP+2
@@ -83,7 +103,12 @@
         ISTHEP(NHEP)=IST(J)
         JMOHEP(1,NHEP)=IQ
         JDAHEP(1,NHEP)=0
+#if !defined(CERNLIB_GFORTRAN)
   10    PHEP(5,NHEP)=RMASS(IDKPRD(J,IM))
+#else
+           PHEP(5,NHEP)=RMASS(IDKPRD(J,IM))
+  10    continue
+#endif
         JMOHEP(2,NHEP-2)=NHEP-1
         JDAHEP(2,NHEP-2)=NHEP-1
         JMOHEP(2,NHEP-1)=NHEP-2
@@ -132,7 +157,12 @@
         JMOHEP(1,NHEP)=IHEP
         JDAHEP(1,NHEP)=0
         PHEP(5,NHEP)=RMASS(IDKPRD(J,IM))
+#if !defined(CERNLIB_GFORTRAN)
   30    CALL HWVZRO(4,VHEP(1,NHEP))
+#else
+           CALL HWVZRO(4,VHEP(1,NHEP))
+  30    continue
+#endif
         JDAHEP(2,IHEP)=NHEP
 C Establish colour connections and select momentum configuration
         IF (NPRODS(IM).EQ.3) THEN
diff -uNr src.ORIG/mclibs/herwig/code/hwdidp.F src/mclibs/herwig/code/hwdidp.F
--- src.ORIG/mclibs/herwig/code/hwdidp.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwdidp.F	2005-05-31 02:34:40.000000000 +0900
@@ -17,7 +17,12 @@
 C---LEPTONS HAVE ID CODES 121-132
       IF (N.EQ.4) ID=ID0+120
       IF (RN.LT.FR) GOTO 30
+#if !defined(CERNLIB_GFORTRAN)
    10 ID=ID+2
+#else
+         ID=ID+2
+   10 continue
+#endif
       ID=ID-2
    30 HWDIDP=ID
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwdthr.F src/mclibs/herwig/code/hwdthr.F
--- src.ORIG/mclibs/herwig/code/hwdthr.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwdthr.F	2005-05-31 02:34:21.000000000 +0900
@@ -14,7 +14,14 @@
       A=P0(5)+P1(5)
       B=P0(5)-P1(5)
       C=P2(5)+P3(5)
+#if !defined(CERNLIB_GFORTRAN)
       IF (B.LT.C) CALL HWWARN('HWDTHR',100,*999)
+#else
+      if (B.LT.C) then
+          call hwwarn('HWDTHR',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       D=ABS(P2(5)-P3(5))
       AA=A*A
       BB=B*B
diff -uNr src.ORIG/mclibs/herwig/code/hwegam.F src/mclibs/herwig/code/hwegam.F
--- src.ORIG/mclibs/herwig/code/hwegam.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwegam.F	2005-05-31 02:34:21.000000000 +0900
@@ -8,6 +8,9 @@
 C     ELSE EQUIVALENT PHOTON APPROX FROM INCOMING E+, E-, MU+ OR MU-
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWRUNI,EGMIN,ZMIN,ZMAX,ZGAM,SS,ZMI,ZMA,
      & PPL,PMI,QT2,Q2,QQMIN,QQMAX,S0,A
       INTEGER IHEP,IHADIS,HQ
@@ -15,7 +18,14 @@
       EXTERNAL HWRGEN,HWRUNI
       DATA EGMIN/5.D0/
       IF (IERROR.NE.0)  RETURN
+#if !defined(CERNLIB_GFORTRAN)
       IF (IHEP.LT.1.OR.IHEP.GT.2) CALL HWWARN('HWEGAM',500,*999)
+#else
+      if (IHEP.LT.1.OR.IHEP.GT.2) then
+          call hwwarn('HWEGAM',500,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       SS=PHEP(5,3)
       IF (IHEP.EQ.1) THEN
         IHADIS=2
@@ -64,7 +74,14 @@
           ZMAX = ONE
         ELSE
 C---UNKNOWN PROCESS: USE ENERGY CUTOFF, AND WARN USER
+#if !defined(CERNLIB_GFORTRAN)
           IF (FSTWGT) CALL HWWARN('HWEGAM',1,*999)
+#else
+          if (FSTWGT) then
+          call hwwarn('HWEGAM',1,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           ZMIN = EGMIN / PHEP(4,IHEP)
           ZMAX = ONE
         ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hweisr.F src/mclibs/herwig/code/hweisr.F
--- src.ORIG/mclibs/herwig/code/hweisr.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hweisr.F	2005-05-31 02:34:21.000000000 +0900
@@ -7,6 +7,9 @@
 C     GENERATES AN ISR PHOTON FROM INCOMING E+, E-, MU+ OR MU-
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,QSQMAX,QSQMIN,A,B,B1,B2,B3,B4,B5,B6,B7,B8,
      $ R,AA,T0,T1,C1,C2,T,Z(2),QSQ(2),PHI(2),C
       INTEGER IHEP,I,J
@@ -15,7 +18,14 @@
 C---IF ZMXISR IS ZERO, THERE CAN BE NO ISR
       IF (ZMXISR.EQ.0 .OR. IPRO.GT.3) RETURN
 C---CHECK CONSISTENCY OF TMNISR AND ZMXISR
+#if !defined(CERNLIB_GFORTRAN)
       IF (ZMXISR**2.LT.TMNISR) CALL HWWARN('HWEISR',200,*999)
+#else
+      if (ZMXISR**2.LT.TMNISR) then
+          call hwwarn('HWEISR',200,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---CALCULATE VIRTUALITY LIMITS
       QSQMAX=4*PHEP(4,IHEP)**2
       QSQMIN=PHEP(5,IHEP)**2
@@ -167,7 +177,12 @@
 C---EVERYTHING WAS GENERATED LAST TIME
       ELSE
 C---ROUTINE CALLED UNEXPECTEDLY
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWEISR',201,*999)
+#else
+        call hwwarn('HWEISR',201,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
 C---IF Z IS TOO LARGE THERE IS NO EMISSION
       IF (Z(IHEP).GT.ZMXISR) RETURN
diff -uNr src.ORIG/mclibs/herwig/code/hwepro.F src/mclibs/herwig/code/hwepro.F
--- src.ORIG/mclibs/herwig/code/hwepro.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwepro.F	2005-05-31 02:34:21.000000000 +0900
@@ -8,6 +8,9 @@
 C     OTHERWISE, CHOOSES AND LOADS ALL VARIABLES FOR HARD PROCESS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN
       EXTERNAL HWRGEN
       IF (IERROR.NE.0)  RETURN
@@ -180,13 +183,23 @@
         WRITE (6,40)
  40     FORMAT (1X,' IPROC=92** is no longer supported.'
      &         /1X,' Please use IPROC=91** instead.')
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWEPRO',500,*999)
+#else
+        call hwwarn('HWEPRO',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ELSEIF(IPRO.EQ.95) THEN
 C---HIGGS PRODUCTION VIA W FUSION IN E P
         CALL HWHIGW
       ELSE
 C---UNKNOWN PROCESS
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWEPRO',102,*999)
+#else
+        call hwwarn('HWEPRO',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
  30   IF (GENEV) THEN
         IF (NOWGT) EVWGT=AVWGT
@@ -205,21 +218,47 @@
         IF (EVWGT.GT.WBIGST) THEN
           WBIGST=EVWGT
           IF (NOWGT.AND.WBIGST.GT.WGTMAX) THEN
+#if !defined(CERNLIB_GFORTRAN)
             IF (NEVHEP.NE.0) CALL HWWARN('HWEPRO',1,*999)
+#else
+            if (NEVHEP.NE.0) then
+          call hwwarn('HWEPRO',1,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             WGTMAX=WBIGST*1.1
             WRITE (6,99) WGTMAX
           ENDIF
         ELSEIF (EVWGT.LT.0.) THEN
+#if !defined(CERNLIB_GFORTRAN)
           IF (EVWGT.LT.-1.D-9) CALL HWWARN('HWEPRO',3,*999)
+#else
+          if (EVWGT.LT.-1.D-9) then
+          call hwwarn('HWEPRO',3,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           EVWGT=0.
         ENDIF
         IF (NEVHEP.NE.0) THEN
 C---LOW EFFICIENCY WARNINGS:
 C   RESET AT 1 PER CENT, STOP AT 1 PER MILLE
           IF (NWGTS.GT.100*NEVHEP) THEN
+#if !defined(CERNLIB_GFORTRAN)
             IF (NWGTS.GT.1000*NEVHEP) CALL HWWARN('HWEPRO',200,*999)
+#else
+            if (NWGTS.GT.1000*NEVHEP) then
+          call hwwarn('HWEPRO',200,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             IF (MOD(NWGTS,10000).EQ.0) THEN
+#if !defined(CERNLIB_GFORTRAN)
               CALL HWWARN('HWEPRO',2,*999)
+#else
+              call hwwarn('HWEPRO',2,iret)
+        if (iret .eq. 1) go to 999
+#endif
               WGTMAX=WBIGST*1.1
               WRITE (6,99) WGTMAX
             ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwetwo.F src/mclibs/herwig/code/hwetwo.F
--- src.ORIG/mclibs/herwig/code/hwetwo.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwetwo.F	2005-05-31 02:34:40.000000000 +0900
@@ -7,6 +7,9 @@
 C     SETS UP 2->2 HARD SUBPROCESS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUPCM,PA,PCM
       INTEGER ICMF,IBM,I,J,K,IHEP
       EXTERNAL HWUPCM
@@ -51,9 +54,21 @@
       ISTHEP(IHEP)=110+I
       JMOHEP(1,IHEP)=ICMF
       JDAHEP(I-2,ICMF)=IHEP
+#if !defined(CERNLIB_GFORTRAN)
    20 PHEP(5,IHEP)=RMASS(IDN(I))
+#else
+         PHEP(5,IHEP)=RMASS(IDN(I))
+   20 continue
+#endif
       PCM=HWUPCM(PHEP(5,NHEP+3),PHEP(5,NHEP+4),PHEP(5,NHEP+5))
+#if !defined(CERNLIB_GFORTRAN)
       IF (PCM.LT.0.) CALL HWWARN('HWETWO',103,*999)
+#else
+      if (PCM.LT.0.) then
+          call hwwarn('HWETWO',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       IHEP=NHEP+4
       PHEP(4,IHEP)=SQRT(PCM**2+PHEP(5,IHEP)**2)
       PHEP(3,IHEP)=PCM*COSTH
@@ -68,6 +83,11 @@
       K=ICO(I)
       IF (K.GT.2) K=K+1
       JMOHEP(2,NHEP+J)=NHEP+K
+#if !defined(CERNLIB_GFORTRAN)
    30 JDAHEP(2,NHEP+K)=NHEP+J
+#else
+         JDAHEP(2,NHEP+K)=NHEP+J
+   30 continue
+#endif
       NHEP=NHEP+5
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwhbgf.F src/mclibs/herwig/code/hwhbgf.F
--- src.ORIG/mclibs/herwig/code/hwhbgf.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwhbgf.F	2005-05-31 02:34:40.000000000 +0900
@@ -39,6 +39,9 @@
 C
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,LEP,Y,Q2,SHAT,Z,PHI,AJACOB,DSIGMA,ME,MP,
      & ML,MREMIF(18),MFIN1(18),MFIN2(18),RS,SMA,W2,RSHAT,FSIGMA(18),
      & SIGSUM,PROB,PRAN,PVRT(4),X
@@ -58,7 +61,14 @@
         ELSEIF (IDHW(1).GE.127.AND.IDHW(1).LE.132) THEN
           LEP=-ONE
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (LEP.EQ.ZERO) CALL HWWARN('HWHBGF',500,*999)
+#else
+        if (LEP.EQ.ZERO) then
+          call hwwarn('HWHBGF',500,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IPROO=MOD(IPROC,100)/10
         IF (IPROO.EQ.0.OR.IPROO.EQ.4) THEN
           IQK=MOD(IPROC,10)
@@ -74,7 +84,12 @@
           IFL=0
           CHARGD=.FALSE.
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHBGF',501,*999)
+#else
+          call hwwarn('HWHBGF',501,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
 C
         LEPFIN = IDHW(1)
@@ -194,7 +209,12 @@
           IDHW(NHEP+5)=164
           IDHW(NHEP+6)=13
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHBGF',503,*999)
+#else
+          call hwwarn('HWHBGF',503,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
       ELSE
 C---Charged current event of specified flavours
@@ -207,9 +227,14 @@
       ENDIF
 C
       DO 1 I=NHEP+1,NHEP+6
+#if !defined(CERNLIB_GFORTRAN)
     1 IDHEP(I)=IDPDG(IDHW(I))
 C
 C---Codes common for all processes
+#else
+          IDHEP(I)=IDPDG(IDHW(I))
+    1 continue
+#endif
       ISTHEP(NHEP+1)=111
       ISTHEP(NHEP+2)=112
       ISTHEP(NHEP+3)=110
diff -uNr src.ORIG/mclibs/herwig/code/hwhbki.F src/mclibs/herwig/code/hwhbki.F
--- src.ORIG/mclibs/herwig/code/hwhbki.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhbki.F	2005-05-31 02:34:21.000000000 +0900
@@ -9,6 +9,9 @@
 C     jet evolution.
 C----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUECM,HWUPCM,HWUSQR,LEP,Y,Q2,SHAT,Z,PHI,AJACOB,
      & DSIGMA,ME,MP,ML,MREMIF(18),MFIN1(18),MFIN2(18),RS,SMA,W2,RSHAT,
      & PGAMMA(5),SG,MF1,MF2,EP,PP,EL,PL,E1,E2,Q1,COSBET,SINBET,COSTHE,
@@ -47,15 +50,32 @@
       PP = PGAM
       A = (W2+Q2-MP**2)/TWO
       PPROT = (A*PGAM-EGAM*SQRT(A**2+MP**2*Q2))/Q2
+#if !defined(CERNLIB_GFORTRAN)
       IF (PPROT.LT.ZERO) CALL HWWARN('HWHBKI',101,*999)
+#else
+      if (PPROT.LT.ZERO) then
+          call hwwarn('HWHBKI',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       EPROT = SQRT(PPROT**2+MP**2)
+#if !defined(CERNLIB_GFORTRAN)
       IF ((EPROT+PPROT).LT.(EP+PP)) CALL HWWARN('HWHBKI',102,*999)
+#else
+      IF ((EPROT+PPROT).LT.(EP+PP)) call hwwarn('HWHBKI',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
       EL = ( PGAM / PPROT * SMA - Q2 ) / TWO
      +     / (EGAM + PGAM / PPROT * EPROT)
       IF (EL.GT.ME) THEN
         PL = SQRT ( EL**2 - ME**2 )
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN ('HWHBKI',103,*999)
+#else
+        call hwwarn('HWHBKI',103,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
       COSBET = (TWO * EPROT * EL - SMA) / (TWO * PPROT * PL)
       IF ( ABS(COSBET) .GE. ONE ) THEN
@@ -66,7 +86,12 @@
       ENDIF
       SG = ME**2 + MPART**2 + Q2 + TWO * RSHAT * EL
       IF (SG.LE.(RSHAT+ML)**2 .OR. SG.GE.(RS-MREMIN)**2)
+#if !defined(CERNLIB_GFORTRAN)
      +    CALL HWWARN ('HWHBKI',104,*999)
+#else
+     +    call hwwarn('HWHBKI',104,iret)
+        if (iret .eq. 1) go to 999
+#endif
       Q1 = HWUPCM( RSHAT, MF1, MF2)
       E1 = SQRT(Q1**2+MF1**2)
       E2 = SQRT(Q1**2+MF2**2)
diff -uNr src.ORIG/mclibs/herwig/code/hwhbrn.F src/mclibs/herwig/code/hwhbrn.F
--- src.ORIG/mclibs/herwig/code/hwhbrn.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhbrn.F	2005-05-31 02:36:52.000000000 +0900
@@ -10,6 +10,9 @@
 C     to the cross-section
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRUNI,HWRGEN,HWUPCM,LEP,Y,Q2,SHAT,Z,PHI,AJACOB,
      & DSIGMA,ME,MP,ML,MREMIF(18),MFIN1(18),MFIN2(18),RS,SMA,W2,RSHAT,
      & MF1,MF2,YMIN,YMAX,YJAC,Q2INF,Q2SUP,Q2JAC,EMW2,ZMIN,ZMAX,ZJAC,
@@ -106,7 +109,12 @@
               EMMAF(I) = MIN(EMMAX,RS-ML-MREMIN)
               IF (EMMIF(I).GT.EMMAF(I)) THEN
                 INCLUD(I)=.FALSE.
+#if !defined(CERNLIB_GFORTRAN)
                 CALL HWWARN('HWHBRN',3,*999)
+#else
+                call hwwarn('HWHBRN',3,iret)
+        if (iret .eq. 1) go to 999
+#endif
                 GOTO 100
               ENDIF
               WMIF(I) = EMMIF(I)+MREMIF(I)
@@ -116,7 +124,12 @@
      +                         PINC*PLMAX)/SMA
               IF (YMIF(I).GT.YMAX) THEN
                 INCLUD(I)=.FALSE.
+#if !defined(CERNLIB_GFORTRAN)
                 CALL HWWARN('HWHBRN',4,*999)
+#else
+                call hwwarn('HWHBRN',4,iret)
+        if (iret .eq. 1) go to 999
+#endif
                 GOTO 100
               ENDIF
             ENDIF
@@ -168,7 +181,14 @@
 C   Approximation
    10     NTRY=0
    20     NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
           IF (NTRY.GT.NETRY) CALL HWWARN('HWHBRN',50,*10)
+#else
+          IF (NTRY.GT.NETRY) then
+            CALL HWWARN('HWHBRN',50,iret)
+            if (iret.eq.1) go to 10
+          endif
+#endif
           Y = (YMIN/YMAX)**HWRGEN(1)*YMAX
           IF (ONE+(ONE-Y)**2.LT.TWO*HWRGEN(2)) GOTO 20
           YJAC=(TWO*LOG(YMAX/YMIN)-TWO*(YMAX-YMIN)
diff -uNr src.ORIG/mclibs/herwig/code/hwhbsg.F src/mclibs/herwig/code/hwhbsg.F
--- src.ORIG/mclibs/herwig/code/hwhbsg.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhbsg.F	2005-05-31 02:34:21.000000000 +0900
@@ -8,6 +8,9 @@
 C     Scale for structure functions and alpha_s selected by BGSHAT
 C----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUALF,HWUAEM,LEP,Y,Q2,SHAT,Z,PHI,AJACOB,DSIGMA,
      & ME,MP,ML,MREMIF(18),MFIN1(18),MFIN2(18),RS,SMA,W2,RSHAT,
      & SFUN(13),ALPHA,LDSIG,DLQ(7),SG,XG,MF1,MF2,MSUM,MDIF,MPRO,FFUN,
@@ -53,7 +56,14 @@
         IF (IFL.EQ.164) EMSCA=SQRT(-U)
       ENDIF
       ALPHAS = HWUALF(1,EMSCA)
+#if !defined(CERNLIB_GFORTRAN)
       IF (ALPHAS.GE.ONE.OR.ALPHAS.LE.ZERO) CALL HWWARN('HWHBSG',51,*888)
+#else
+      if (ALPHAS.GE.ONE.OR.ALPHAS.LE.ZERO) then
+          call hwwarn('HWHBSG',51,iret)
+          if (iret .eq. 1) go to 888
+        endif
+#endif
 C---structure functions
       ETA = (SHAT+Q2)/SMA/Y
       IF (ETA.GT.ONE) ETA=ONE
diff -uNr src.ORIG/mclibs/herwig/code/hwhdis.F src/mclibs/herwig/code/hwhdis.F
--- src.ORIG/mclibs/herwig/code/hwhdis.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhdis.F	2005-05-31 02:34:40.000000000 +0900
@@ -7,6 +7,9 @@
 C     DEEP INELASTIC LEPTON-HADRON SCATTERING: MEAN EVWGT = SIGMA IN NB
 C----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWRUNI,HWUPCM,PRAN,PROB,SAMP,SIG,Q2,
      & XBJ,Y,W,S,MLEP,MHAD,MLSCAT,LEP,YMIN,YMAX,XXMAX,Q2JAC,XXJAC,
      & JACOBI,A1,A2,A3,B1,B2,PCM,PCMEP,PCMLW,PCMEQ,PCMLQ,COSPHI,PA,
@@ -35,7 +38,12 @@
         ELSEIF (IDHW(1).GE.127.AND.IDHW(1).LE.132) THEN
           LEP=-ONE
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHDIS',500,*999)
+#else
+          call hwwarn('HWHDIS',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
         DCHRG=FLOAT(MOD(IDHW(1)  ,2))
         DNEUT=FLOAT(MOD(IDHW(1)+1,2))
@@ -49,7 +57,12 @@
         IF (CHARGD) THEN
           IF ((EPOLN(3)-PPOLN(3)).EQ.1.) THEN
              WRITE(6,5)
+#if !defined(CERNLIB_GFORTRAN)
              CALL HWWARN('HWHDIS',501,*999)
+#else
+             call hwwarn('HWHDIS',501,iret)
+        if (iret .eq. 1) go to 999
+#endif
   5          FORMAT(1X,'WARNING: Cross-section is zero for the',
      &                ' specified lepton helicity')
           ENDIF
@@ -158,14 +171,24 @@
         PCMEQ=HWUPCM(SQRT(SHAT),MLEP,RMASS(IDN(2)))
         PCMLQ=HWUPCM(SQRT(SHAT),MLSCAT,RMASS(IDN(4)))
         IF (PCMLQ.LT.0.) THEN
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHDIS',101,*999)
+#else
+          call hwwarn('HWHDIS',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ELSEIF (PCMLQ.EQ.0.) THEN
           COSTH=ZERO
         ELSE
           COSTH=(TWO*SQRT(PCMEQ**2+MLEP**2)*SQRT(PCMLQ**2+MLSCAT**2)
      &         -(Q2+MLEP**2+MLSCAT**2))/(TWO*PCMEQ*PCMLQ)
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (ABS(COSTH).GT.ONE) CALL HWWARN('HWHDIS',102,*999)
+#else
+        IF (ABS(COSTH).GT.ONE) call hwwarn('HWHDIS',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
         IDCMF=15
         CALL HWETWO
       ELSE
@@ -237,8 +260,13 @@
         CALL HWSFUN(XBJ,EMSCA,IDHW(IHAD),NSTRU,DISF,2)
 C---SWITCH OFF ANY FLAVOURS THAT ARE BELOW THRESHOLD
         DO 90 I=1,12
+#if !defined(CERNLIB_GFORTRAN)
  90     IF (W.LT.2*RMASS(I)) DISF(I,1)=0
 C---EVALUATE DIFFERENTIAL CROSS SECTION
+#else
+           IF (W.LT.2*RMASS(I)) DISF(I,1)=0
+ 90     continue
+#endif
         IF (CHARGD) THEN
           PROP=RMASS(198)**2/(Q2+RMASS(198)**2)
           EFACT=FACT*(HWUAEM(-Q2)*PROP)**2/XBJ
diff -uNr src.ORIG/mclibs/herwig/code/hwhdyp.F src/mclibs/herwig/code/hwhdyp.F
--- src.ORIG/mclibs/herwig/code/hwhdyp.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhdyp.F	2005-05-31 04:20:14.000000000 +0900
@@ -10,6 +10,10 @@
 C     MEAN EVWGT = SIGMA IN NB
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+      double precision pthtst
+#endif
       DOUBLE PRECISION HWRGEN,HWRUNI,HWUAEM,EPS,C1,C2,C3,EMSQZ,EMGMZ,
      & EMSQZP,EMGMZP,CQF(7,6,16),QPOW,RPOW,A01,A1,A02,A2,A03,A3,CRAN,
      & EMJ1,EMJ2,EMJ3,EMJAC,FACT,QSQ,HCS,FACTR,RCS,EXTRA,PMAX,PTHETA
@@ -47,7 +51,12 @@
             JLMN=11
             JLMX=16
           ELSE
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWHDYP',500,*999)
+#else
+            call hwwarn('HWHDYP',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ENDIF
 C Set up parameters for importance sampling:
 C sum of power law and two Breit-Wigners (relative weights C1,C2,C3)
@@ -55,9 +64,30 @@
           C2=ONE
           C3=ZERO
           IF (ZPRIME) C3=ONE
+#if !defined(CERNLIB_GFORTRAN)
           IF (EMPOW.EQ.1) CALL HWWARN('HWHDYP',501,*999)
+#else
+          if (EMPOW.EQ.1) then
+          call hwwarn('HWHDYP',501,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
           IF (C2.EQ.0) CALL HWWARN('HWHDYP',502,*999)
+#else
+          if (C2.EQ.0) then
+          call hwwarn('HWHDYP',502,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
           IF (C3.EQ.0.AND.ZPRIME) CALL HWWARN('HWHDYP',503,*999)
+#else
+          if (C3.EQ.0.AND.ZPRIME) then
+          call hwwarn('HWHDYP',503,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           QPOW=-EMPOW+1
           RPOW=1/QPOW
           EMSQZ=RMASS(200)**2
@@ -123,6 +153,7 @@
   40    CONTINUE
   50    CONTINUE
       ENDIF
+C#if 0
 C
       HCS=0.
       DO 90 I=1,2
@@ -183,7 +214,15 @@
   100 COSTH=HWRUNI(0,-ONE,ONE)
       PTHETA=CQF(1,IQ,JF)*(1.+COSTH**2)+CQF(3,IQ,JF)*COSTH
      &      +EXTRA*(1.-COSTH)
+#if !defined(CERNLIB_GFORTRAN)
       IF (PTHETA.LT.PMAX*HWRGEN(1)) GOTO 100
+#else
+      pthtst = HWRGEN(1)
+      pthtst = pthtst * pmax
+      if (ptheta.lt.pthtst) then
+         goto 100
+      endif
+#endif
       IF (ID1.GT.ID2) COSTH=-COSTH
       IDCMF=200
       CALL HWETWO
diff -uNr src.ORIG/mclibs/herwig/code/hwhegg.F src/mclibs/herwig/code/hwhegg.F
--- src.ORIG/mclibs/herwig/code/hwhegg.F	1996-12-03 23:16:55.000000000 +0900
+++ src/mclibs/herwig/code/hwhegg.F	2005-05-31 02:34:21.000000000 +0900
@@ -11,6 +11,9 @@
 C     AND TIMES BRANCHING FRACTION IF WW
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWULDO,EMSQ,BETA,S,T,U,TMIN,TMAX,TRAT,
      & DSDT,PROB,X,Z(2),ZMIN,ZMAX,PCMIN,PCMAX,PCFAC,PLOGMI,PLOGMA,PTCMF,
      & Q,PC,BLOG,EMCMIN,EMCMAX,EMLMIN,EMLMAX,WGT(6),RWGT,CV,CA,BR,QT(2),
@@ -54,7 +57,12 @@
           NQ=1
           NADD=1
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWHEGG',200,*999)
+#else
+          call hwwarn('HWHEGG',200,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
 C-----SPLIT ELECTRONS TO PHOTONS
         NHEP=3
@@ -129,7 +137,14 @@
         JGAM=3-IGAM
 C-----CHOOSE ITS PT
  30     NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NTRY.GT.NBTRY) CALL HWWARN('HWHEGG',100,*999)
+#else
+        if (NTRY.GT.NBTRY) then
+          call hwwarn('HWHEGG',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         QT(IGAM)=(PCM(IGAM)/PCF(IGAM))**HWRGEN(2)
         PROB=(QT(IGAM)**2/(QT(IGAM)**2+1))**2
         QT(IGAM)=QT(IGAM)*PCF(IGAM)
@@ -212,7 +227,14 @@
         IF (IHPRO.LE.9) THEN
 C-------FOR FFBAR, CHOOSE T ACCORDING TO -SHAT/T
  60       NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
           IF (NTRY.GT.NBTRY) CALL HWWARN('HWHEGG',101,*999)
+#else
+          if (NTRY.GT.NBTRY) then
+          call hwwarn('HWHEGG',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           T=TRAT**HWRGEN(3)*TMIN
           U=-T-SHAT
 C-------REWEIGHT TO CORRECT DISTRIBUTION
@@ -224,7 +246,14 @@
         ELSE
 C-------FOR WW, CHOOSE T ACCORDING TO (SHAT/T)**2
  70       NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
           IF (NTRY.GT.NBTRY) CALL HWWARN('HWHEGG',102,*999)
+#else
+          if (NTRY.GT.NBTRY) then
+          call hwwarn('HWHEGG',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           T=TMAX/(1-(1-TRAT)*HWRGEN(4))
           U=-T-SHAT
 C-------REWEIGHT TO CORRECT DISTRIBUTION
